﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Text;
using TreeLib;

namespace TreeLibTests
{
    [TestClass]
    public class TestBinaryTree
    {
        //[TestMethod]
        //public void HeightOfEmptyTree()
        //{
        //    BinaryTree<string, int> emptyTree = new BinaryTree<string, int>();
        //    Assert.AreEqual(-1, emptyTree.Height());
        //}

        //[TestMethod]
        //public void InsertOneNodeTest()
        //{
        //    BinaryTree<string, int> tree = new BinaryTree<string, int>();
        //    tree.Insert("abc", 10);
        //    Assert.AreEqual(0, tree.Height());
        //}

        //[TestMethod]
        //public void InsertTestThreeNodesTest()
        //{
        //    BinaryTree<string, int> tree = new BinaryTree<string, int>();
        //    tree.Insert("abc", 10);
        //    tree.Insert("bcd", 11);
        //    tree.Insert("cde", 12);
        //    Assert.AreEqual(2, tree.Height());
        //}

        //[TestMethod]
        //public void smallInOrderTraversal()
        //{
        //    BinaryTree<string, int> tree = new BinaryTree<string, int>();
        //    tree.Insert("j", 10);
        //    tree.Insert("d", 11);
        //    tree.Insert("r", 12);

        //    string[] key = new string[] { "d", "j", "r" };
        //    int[] value = new int[] { 11, 10, 12 };

        //    int result = 0;

        //    foreach (Tuple<string, int> nodeValue in tree.InOrderTraversal())
        //    {
        //        Assert.AreEqual(key[result].ToString(), nodeValue.Item1);
        //        Assert.AreEqual(value[result++], nodeValue.Item2);
        //    }
        //}


        //[TestMethod]
        //public void largeInOrderTraversal()
        //{
        //    const int PAYLOAD = 10;
        //    BinaryTree<string, int> tree = new BinaryTree<string, int>();
        //    tree.Insert("u", PAYLOAD);
        //    tree.Insert("n", PAYLOAD);
        //    tree.Insert("i", PAYLOAD);
        //    tree.Insert("v", PAYLOAD);
        //    tree.Insert("e", PAYLOAD);
        //    tree.Insert("r", PAYLOAD);
        //    tree.Insert("s", PAYLOAD);
        //    tree.Insert("t", PAYLOAD);
        //    tree.Insert("y", PAYLOAD);
        //    tree.Insert("o", PAYLOAD);
        //    tree.Insert("f", PAYLOAD);
        //    tree.Insert("l", PAYLOAD);
        //    tree.Insert("c", PAYLOAD);
        //    tree.Insert("h", PAYLOAD);
        //    tree.Insert("b", PAYLOAD);
        //    tree.Insert("g", PAYLOAD);

        //    // Inorder traversal of binary tree should yield a sorted order
        //    string name = "universtyoflchbg";
        //    char[] charArray = name.ToCharArray();
        //    Array.Sort(charArray);

        //    int result = 0;
        //    foreach (Tuple<string, int> nodeTuple in tree.InOrderTraversal())
        //    {
        //        Assert.AreEqual(charArray[result++].ToString(), nodeTuple.Item1);
        //        Assert.AreEqual(PAYLOAD, nodeTuple.Item2);
        //    }
        //}

        //[TestMethod]
        //public void insertAtLeafTest()
        //{
        //    BinaryTree<string, int> tree = new BinaryTree<string, int>();
        //    tree.Insert("J", 10);
        //    Assert.AreEqual("(J)", tree.ToString());

        //    tree.Insert("E", 10);
        //    Assert.AreEqual("(J (E) ())", tree.ToString());

        //    tree.Insert("P", 10);
        //    Assert.AreEqual("(J (E) (P))", tree.ToString());

        //    tree.Insert("A", 10);
        //    Assert.AreEqual("(J (E (A) ()) (P))", tree.ToString());

        //    tree.Insert("C", 10);
        //    Assert.AreEqual("(J (E (A () (C)) ()) (P))", tree.ToString());

        //    tree.Insert("M", 10);
        //    Assert.AreEqual("(J (E (A () (C)) ()) (P (M) ()))",
        //        tree.ToString());

        //    tree.Insert("S", 10);
        //    Assert.AreEqual("(J (E (A () (C)) ()) (P (M) (S)))",
        //        tree.ToString());
        //}

        //[TestMethod]
        //public void rotateLeftTest()
        //{
        //    Node<string, int> node =
        //        new Node<string, int>("U", 10);

        //    Node<string, int>.Insert(node, "N", 10);
        //    Node<string, int>.RotateRight(ref node);
        //    StringBuilder builder = new StringBuilder();
        //    node.ToString(builder);
        //    Assert.AreEqual("N () (U)", builder.ToString());
        //}

        //[TestMethod]
        //public void rotateRightTest()
        //{
        //    Node<string, int> node =
        //        new Node<string, int>("N", 10);
        //    Node<string, int>.Insert(node, "U", 10);
        //    Node<string, int>.RotateLeft(ref node);
        //    StringBuilder builder = new StringBuilder();
        //    node.ToString(builder);
        //    Assert.AreEqual("U (N) ()", builder.ToString());
        //}

        //[TestMethod]
        //public void nodeInsertAtRoot()
        //{
        //    Node<string, int> root = new
        //        Node<string, int>("U", 10);
        //    Node<string, int>.InsertAtRoot(ref root, "N", 10);
        //    StringBuilder builder = new StringBuilder();
        //    root.ToString(builder);
        //    Assert.AreEqual("N () (U)", builder.ToString());

        //    Node<string, int>.InsertAtRoot(ref root, "I", 10);
        //    Node<string, int>.InsertAtRoot(ref root, "V", 10);
        //    Node<string, int>.InsertAtRoot(ref root, "E", 10);
        //    Node<string, int>.InsertAtRoot(ref root, "R", 10);
        //    Node<string, int>.InsertAtRoot(ref root, "S", 10);
        //    Node<string, int>.InsertAtRoot(ref root, "T", 10);
        //    builder.Clear();
        //    root.ToString(builder);
        //    Assert.AreEqual("T (S (R (E () (I () (N))) ()) ()) (V (U) ())",
        //        builder.ToString());
        //    Node<string, int>.InsertAtRoot(ref root, "Y", 10);
        //    builder.Clear();
        //    root.ToString(builder);
        //    Assert.AreEqual("Y (T (S (R (E () (I () (N))) ()) ()) (V (U) ())) ()",
        //        builder.ToString());
        //    Node<string, int>.InsertAtRoot(ref root, "O", 10);
        //    builder.Clear();
        //    root.ToString(builder);
        //    Assert.AreEqual("O (E () (I () (N))) (Y (T (S (R) ()) (V (U) ())) ())",
        //        builder.ToString());
        //    Node<string, int>.InsertAtRoot(ref root, "F", 10);


        //    builder.Clear();
        //    root.printConnections(builder);
        //    string connections = builder.ToString();

        //    builder.Clear();
        //    root.ToString(builder);
        //    Assert.AreEqual("F (E) (O (I () (N)) (Y (T (S (R) ()) (V (U) ())) ()))",
        //        builder.ToString());


        //    Node<string, int>.InsertAtRoot(ref root, "L", 10);
        //    builder.Clear();
        //    root.ToString(builder);
        //    Assert.AreEqual("L (F (E) (I)) (O (N) (Y (T (S (R) ()) (V (U) ())) ()))",
        //       builder.ToString());
        //    root.printConnections(builder);
        //    connections = builder.ToString();
        //    builder.Clear();
        //}
    }
}
